require.config({
	paths : {
		text : "lib/text"
	}
});

// Funzione per terminare tutte le richieste Ajax pendenti
$.ajaxQ = (function() {
	var id = 0, Q = {};

	$(document).ajaxSend(function(e, jqx) {
		jqx._id = ++id;
		Q[jqx._id] = jqx;
	});
	$(document).ajaxComplete(function(e, jqx) {
		if (jqx != undefined) {
			delete Q[jqx._id];
		}
	});

	return {
		abortAll : function() {
			var r = [];
			$.each(Q, function(i, jqx) {
				r.push(jqx._id);
				jqx.abort();
			});
			return r;
		}
	};
})();

function init(Router, Utils, $$, f7, language, loadPreferences) {
	// Labels multilingua
	var lbl = Utils.getAppLabels(language);

	f7.params.modalButtonOk = Template7.global.lbl.MODAL_BUTTON_OK;
	f7.params.modalButtonCancel = Template7.global.lbl.MODAL_BUTTON_CANCEL;
	f7.params.modalPreloaderTitle = Template7.global.lbl.MODAL_PRELOADER_TITLE;
	f7.params.modalUsernamePlaceholder = Template7.global.lbl.MODAL_USERNAME_PLACEHOLDER;
	f7.params.modalPasswordPlaceholder = Template7.global.lbl.MODAL_PASSWORD_PLACEHOLDER;
	f7.params.smartSelectBackText = Template7.global.lbl.SMART_SELECT_BACK_TEXT;
	f7.params.smartSelectPopupCloseText = Template7.global.lbl.SMART_SELECT_POPUP_CLOSE_TEXT;
	f7.params.smartSelectPickerCloseText = Template7.global.lbl.SMART_SELECT_PICKER_CLOSE_TEXT;
	f7.params.notificationCloseButtonText = Template7.global.lbl.NOTIFICATION_CLOSE_BUTTON_TEXT;

	f7.showPreloader(Template7.global.lbl.STARTING_APP);

	// Costanti relative a modalità di funzionamento
	Template7.global.MODE_HEATING = 0;
	Template7.global.MODE_COOLING = 1;
	Template7.global.MODE_DEHUMIDIFICATION = 3;
	Template7.global.MODE_FANONLY = 4;
	Template7.global.MODE_AUTO = 5;
	Template7.global.defaultUrlCloud = "http://innovaenergie.cloud/api/v/1/";
	//Template7.global.defaultUrlCloud = "http://cloud-innova.kumbe.it/api/v/1/";
	Template7.global.defaultUrl = "http://192.168.4.1/api/v/1/";
	Template7.global.namespace = "it.kumbe.innovapp20";
	Template7.global.ESSID_default = "Innova2.0";
	Template7.global.appVersion = "1.0.18";
	Template7.global.urlTermsConditions = "http://www.innovaenergie.com/privacy";

	Template7.global.testVersion = false;
	var testVersion = parseInt(Utils.getLocalConfig("testVersion", 0));
	if (testVersion == 1) {
		Template7.global.testVersion = true;
		Template7.global.localUser = Utils.getLocalConfig("localUser", "moreno");
	}

	if (Utils.isPhoneGap()) {
		Template7.global.localTest = false;

		Template7.global.scanRangeStart = 0;
		Template7.global.scanRangeStop = 255;
		Template7.global.scanThreads = 10;
	} else {
		// Forzatura per desktop
		//Template7.global.localTest = true;
		Template7.global.localTest = false;

		Template7.global.scanRangeStart = 1;
		Template7.global.scanRangeStop = 255;
		Template7.global.scanThreads = 10;
	}

	if (Template7.global.localTest == true || Template7.global.testVersion == true) {
		if (Template7.global.localUser == "marco") {
			Template7.global.defaultUrl = "http://192.168.0.99:8080/mobile.kumbe.it/trunk/innova_2.0/esp8266/trunk/simulator/api/v/1/";
		} else {
			Template7.global.defaultUrl = "http://192.168.0.249/mobile.kumbe.it/trunk/innova_2.0/esp8266/trunk/simulator/api/v/1/";
		}
	}
	
	// Google Analytics
	ga('create', 'UA-75140621-1', 'auto');

	ga('set', 'checkProtocolTask', null);
	
	// Split-view
	$(window).resize(function() {
		scr.w = $(window).width();

		if (scr.w >= 769) {
			f7.closePanel();
			$('.views').width("calc(100% - 320px)");
		} else {
			$('.views').width("100%");
		}
	});

	$(document).ajaxSend(function(evt, request, settings) {
		if (settings != undefined && settings.url != undefined && settings.extraData == undefined) {
			f7.showIndicator();
		}
	});

	$(document).ajaxError(function(evt, request, settings) {
		if (settings != undefined && settings.url != undefined && settings.extraData == undefined) {
			f7.hideIndicator();
		}
	});

	$(document).ajaxComplete(function(e, xhr, settings) {
		if (settings != undefined && settings.url != undefined && settings.extraData == undefined) {
			f7.hideIndicator();
		}
	});

	// Helper if_eq
	Template7.registerHelper('if_eq', function(a, b, opts) {
		if (a == b) // Or === depending on your needs
			return opts.fn(this);
		else
			return opts.inverse(this);
	});

	// Helper if_not_eq
	Template7.registerHelper('if_not_eq', function(a, b, opts) {
		if (a != b) // Or !== depending on your needs
			return opts.fn(this);
		else
			return opts.inverse(this);
	});

	// Helper if_even
	Template7.registerHelper('if_even', function(conditional, options) {
		if ((conditional % 2) == 0)
			return options.fn(this);
		else
			return options.inverse(this);
	});

	// Helper upperCase
	Template7.registerHelper('toUppercase', function(str) {
		return str.toUpperCase();
	});

	// Se trovo la connessione o meno
	if (Utils.isPhoneGap() && navigator.connection !== undefined) {
		var networkState = navigator.connection.type;
		var states = {};
		states[navigator.connection.UNKNOWN] = 'Unknown connection';
		states[navigator.connection.ETHERNET] = 'Ethernet connection';
		states[navigator.connection.WIFI] = 'WiFi connection';
		states[navigator.connection.CELL_2G] = 'Cell 2G connection';
		states[navigator.connection.CELL_3G] = 'Cell 3G connection';
		states[navigator.connection.CELL_4G] = 'Cell 4G connection';
		states[navigator.connection.CELL] = 'Cell generic connection';
		states[navigator.connection.NONE] = 'No network connection';

		if (states[networkState] == 'No network connection') {
			Utils.setLocalConfig("connected", false);
		} else {
			Utils.setLocalConfig("connected", true);
		}
	} else {
		// Sono su desktop
		Utils.setLocalConfig("connected", true);
	}

	document.addEventListener("online", function() {
		Utils.setLocalConfig("connected", true);
	}, false);

	document.addEventListener("offline", function() {
		Utils.setLocalConfig("connected", false);
	}, false);

	// tasto menu Android
	document.addEventListener("menubutton", function() {
		if (f7.params.swipePanel == 'left') {
			f7.openPanel("left");
		}
	}, false);

	$$('.scan-network .item-title').html(Template7.global.lbl.SCAN_NETWORK);
	$$('.add-new-device .item-title').html(Template7.global.lbl.ADD_MANUALLY);

	$('body').delegate('.scan-network', 'click', function() {
		requirejs([ 'js/devices/devicesController' ], function(Ref) {
			Ref.scanNetwork();
		});
	});

	$('body').delegate('.add-new-device', 'click', function() {
		f7.closeModal();

		// Rimuovo il dispositivo corrente per cercare nella mia rete attuale
		// (defaultUrl)
		Utils.unsetCurrentDevice();

		Utils.networkConnection({
			app : {
				utils : Utils
			}
		});
	});

	if (Utils.isPhoneGap() && window.device.platform == "Android") {
		Utils.checkWifiMaxError = 3;
	}
	if (Utils.isPhoneGap() && window.device.platform == "iOS") {
		Utils.checkWifiMaxError = 2;
	}

	Router.init(f7);

	$$(document).on('pageBeforeAnimation', function(e) {
		if (e.detail.page.name == "intro" || e.detail.page.name == "setup") {
			// Larghezza massima per intro, e setup
			if ($(window).width() > 769) {
				$('.views').width("100%");
			}
		} else {
			if ($(window).width() > 769) {
				$('.views').width("calc(100% - 320px)");
			}
		}
	});

	$$(document).on('pageAfterAnimation', function(e) {
		$('.view-main .page-on-left.page[data-page="'+e.detail.page.name+'"]').remove();
		$('.view-main .page-on-left.page').last().removeClass("cached");
	});

	// Refresh dello stato dell'homepage tornando indietro dal calendario
	f7.onPageAfterBack('calendar', function(page) {
		requirejs([ 'js/homepage/homepageController' ], function(Ref) {
			Ref.refreshStatus();
		});
	});

	// Refresh della lista di dispositivi tornando indietro dalla ricerca degli
	// stessi nella rete
	f7.onPageAfterBack('popup-devices', function(page) {
		requirejs([ 'js/devices/devicesController' ], function(Ref) {
			Ref.refreshDevices();
		});
	});

	// Refresh del dettaglio del calendario tornando indietro dall'elenco dei
	// periodi
	f7.onPageAfterBack('calendar-period', function(page) {
		requirejs([ 'js/calendar/calendarController' ], function(Ref) {
			Ref.refreshCalendar();
		});
	});

	// Refresh della lista di periodi del calendario tornando indietro dalla
	// modifica/nuovo di un calendario
	f7.onPageAfterBack('calendar-period-edit', function(page) {
		requirejs([ 'js/calendar-period/calendar-periodController' ], function(Ref) {
			Ref.refreshPeriods();
		});
	});

	if (!Utils.isPhoneGap()) {
		Utils.acceptTerms({
			callback_accept : function() {
				// Effettuo il sync del localStorage
				Utils.syncLocalStorage({
					callback : function(data) {
						// Versione desktop
						if (loadPreferences) {
							Router.load('preferences', {
								language : language,
								push_notification : true,
								back : false
							});
						} else {
							// Dispositivo preferito
							var preferredDevice = Utils.getPreferredDevice();
							if (preferredDevice == false) {
								Utils.Log("No preferred device available, loading intro");
								Router.load('intro', {});
							} else {
								Utils.Log("Loading homepage");
								Utils.setCurrentDevice(preferredDevice);
								Router.load('homepage', {});
							}
						}
					}
				});
			},
			callback_decline : function() {
				window.location.reload();
			}
		});		
	} else {
		Utils.acceptTerms({
			callback_accept : function() {
				// Versione non desktop
				if (loadPreferences) {
					Router.load('preferences', {
						language : language
					});
				} else {
					window.plugins.uniqueDeviceID.get(function(phone_id) {
						Utils.setLocalConfig("phone_id", phone_id);

						// Dispositivo preferito
						var preferredDevice = Utils.getPreferredDevice();
						if (preferredDevice == false) {
							Utils.Log("No preferred device available, first start, loading intro");
							Router.load('intro', {});
						} else {
							Utils.setCurrentDevice(preferredDevice);

							// Registro le notifiche PUSH
							var push_notif = Utils.getLocalConfig("push_notification");
							if (push_notif == true || push_notif == "true") {
								Utils.RegisterPushNotification();
							}

							if (preferredDevice.getStandalone() == true) {
								// Dispositivo standalone, mi collego
								// alla sua rete
								// automaticamente e vi accedo
								Utils.networkConnection({
									SSID : Template7.global.ESSID_default + "_" + preferredDevice.getName(),
									password : preferredDevice.getPassword(),
									app : {
										utils : Utils
									}
								});
							} else {
								// Dispositivo su cloud, lo visualizzo
								// direttamente se
								// presente la connesione ad internet
								Utils.checkSetup({
									utils : Utils
								});
							}
						}
					}, function() {
						Router.load('modal', {
							title : Template7.global.lbl.WARNING,
							message : Template7.global.lbl.CONNECT_TO + ": <b>" + Template7.global.ESSID_default + "_" + current_device.name,
							buttons : {
								reload : true
							}
						});
					});
				}
			},
			callback_decline : function() {
				navigator.app.exitApp();
			}
		});	
	}
}

function deviceReady(Router, Utils, $$, f7) {
	// Globalization
	var lingua = Utils.getLocalConfig("language");
	if (lingua == undefined) {
		if (navigator.globalization != undefined) {
			navigator.globalization.getPreferredLanguage(function(language) {
				Utils.Log("Globalization succeded: " + language.value);
				if(language.value != undefined) {
					var l = language.value.split("-");
					init(Router, Utils, $$, f7, l[0].toLowerCase(), true);
				} else {
					init(Router, Utils, $$, f7, Template7.global.defaultLanguage, true);
				}				
			}, function() {
				Utils.Log("Globalization failed, language: " + Template7.global.defaultLanguage);
				init(Router, Utils, $$, f7, Template7.global.defaultLanguage, true);
			});
		} else {
			// Desktop
			var userLang = (navigator.language || navigator.userLanguage).split("-");
			init(Router, Utils, $$, f7, userLang[0], true);
		}
	} else {
		init(Router, Utils, $$, f7, lingua, false);
	}
}

define('app', [ 'js/router', 'js/utils' ], function(Router, Utils) {
	// Cordova & plugins
	if (Utils.isPhoneGap()) {
		// Se sono su Android aggiungo Content-Security-Policy
		if( navigator.userAgent.match( /Android/i ) ) {
			$('head').append('<meta http-equiv="Content-Security-Policy"/>');
		}	
		
		$('head').append('<script type="text/javascript" charset="utf-8" src="cordova.js"></script>');
		$('head').append('<script type="text/javascript" src="lib/networkinterface.js"></script>');
		$('head').append('<script type="text/javascript" src="lib/pushNotification.js"></script>');
	} else {
		$("body").addClass("desktop");
		$(".view").addClass("desktop");
	}
	
	// Define Dom7
	var $$ = Dom7;
	
	$$('.view-main').html('<div class="pages"></div>');

	var f7 = new Framework7({
		material : true,
		materialRipple : true,
		materialRippleElements : '.ripple, a.link, .item-link, a.item-link, .button, .modal-button, .tab-link, .label-radio, .label-checkbox, .actions-modal-button, a.searchbar-clear, .floating-button',
		uniqueHistory : true,
		uniqueHistoryIgnoreGetParameters : true,
		dynamicPageUrl : 'content-{{name}}',
		swipePanel : false,
		sortable : false,
		animateNavBackIcon : true,
		animatePages : true,
		template7Pages : true,
		modalTitle : 'InnovApp 2.0',
		popupCloseByOutside : false,
		template7Pages : true
	});

	Template7.global = {};

	Template7.global.isoLangs = isoLangs;
	Template7.global.languages = [ "cs", "de", "en", "fr", "it", "sk", "nl", "pt" ];
	Template7.global.defaultLanguage = "en";
	
	Utils.setRouter(Router);

	// Change class
	$$('.view.navbar-through').removeClass('navbar-through').addClass('navbar-fixed');

	var mainView = f7.addView('.view-main', {
		dynamicNavbar : true,
		domCache : true
	});
	
	// Back button
	document.addEventListener("backbutton", function() {
		if ($$('.modal-in').length > 0) {
			f7.closeModal();
			return false;
		} else {
			if (mainView.history.length > 1) {
				mainView.router.back();
			} else {
				Utils.exitAppPopup();
			}
		}
	}, false);

	Utils.setApp(f7, $$, mainView);
	
	if (Utils.isPhoneGap()) {
		document.addEventListener("deviceready", function() {
			deviceReady(Router, Utils, $$, f7);
		});
	} else {
		deviceReady(Router, Utils, $$, f7);
	}

	return {
		f7 : f7,
		$$ : $$,
		mainView : mainView,
		router : Router,
		utils : Utils
	};
});