define([ "app", "text!js/homepage/prerender.html", "js/homepage/homepageStatusView", "js/homepage/homepageView" ], function(app, Template, View, HomepageView) {
	var bindings_h = [ {
		element : '.fn-set-address',
		event : 'click',
		handler : function() {
			var address = prompt("Indirizzo ip", app.utils.getLocalConfig("urlApp"));
			app.utils.setLocalConfig("urlApp", address);
		}
	}, {
		element : '.fn-test',
		event : 'click',
		handler : function() {
			app.utils.setLocalConfig("testVersion", (Template7.global.testVersion == true) ? 0 : 1);
			window.location.reload();
		}
	}, {
		element : '.fn-internet-connection',
		event : 'click',
		handler : showNetworks
	}, {
		element : '.fn-open-home',
		event : 'click',
		handler : showHomepage
	}, {
		element : '.fn-mydevices',
		event : 'click',
		handler : showMyDevices
	}, {
		element : '.fn-advanced',
		event : 'click',
		handler : showAdvanced
	}, {
		element : '.fn-feedback',
		event : 'click',
		handler : showFeedback
	}, {
		element : '.fn-manual',
		event : 'click',
		handler : showManual
	}, {
		element : '.fn-preferences',
		event : 'click',
		handler : showPreferences
	}, {
		element : '.fn-labels',
		event : 'click',
		handler : showLabels
	}, {
		element : '.set-power',
		event : 'click',
		handler : setMode
	} ];

	var bindings_s = [ {
		element : '.set-mode',
		event : 'click',
		handler : setMode
	}, {
		element : '.modes',
		event : 'click',
		handler : showModes
	}, {
		element : '.open-calendar',
		event : 'click',
		handler : showCalendar
	}, {
		element : '.fn-alarm',
		event : 'click',
		handler : showAlarms
	}, {
		element : '.fn-power',
		event : 'click',
		handler : setMode
	}, {
		element : '.in-standby',
		event : 'click',
		handler : inStandby
	}, {
		element : '.refresh',
		event : 'click',
		handler : function() {
			refreshStatus();
		}
	} ];
	
	var dev={};
	function init() {
		app.f7.hidePreloader();
		app.f7.showIndicator();

		app.utils.Log("INIT homepageController");

		var compiled_template = Template7.compile(Template);
		var html = compiled_template({});

		app.mainView.router.loadContent(html);

		HomepageView.render({
			bindings : bindings_h
		});

		app.utils.googleAnalytics('send', 'pageview', {
			'page' : 'homepage'
		});
		
		// Nascondo avanzate se non in cloud
		var current_device = app.utils.getCurrentDevice();
		if (current_device.getStandalone() == true) {
			$('.fn-advanced').parent().parent().addClass("hidden");
			$('.fn-feedback').parent().parent().addClass("hidden");
		} else {
			// Nascondo la gestione della connessione ad internet se non sono in
			// modalità standalone
			if (Template7.global.localTest == false && Template7.global.testVersion == false) {
				// Nascondo la scheda avanzate per i non test
				$('.fn-feedback').parent().parent().addClass("hidden");
			}
			$('.fn-internet-connection').parent().parent().addClass("hidden");
		}

		if (Template7.global.localTest == false && Template7.global.testVersion == false) {
			$('.fn-test').parent().parent().addClass("hidden");
			$('.fn-set-address').parent().parent().addClass("hidden");
		}

		$('.pull-to-refresh-content').unbind('refresh');
		$('.pull-to-refresh-content').bind('refresh', function(e) {
			e.stopPropagation();
			refreshStatus();
		});

		setTimeout(function() {
			// $('.screensaver').hide();

			loadStatus();
		}, 500);
	}
	
	function refreshStatus(parameters) {
		if (parameters == undefined) {
			parameters = {};
		}
		if (parameters.skipNotification == undefined) {
			parameters.skipNotification = false;
		}

		app.f7.showIndicator();
		loadStatus(parameters);
		app.f7.pullToRefreshDone();
	}

	function getCalendarHour(nextChange) {
		if (nextChange != undefined) {
			var r = parseInt(nextChange) % 48, v = "" + Math.floor(r / 2);
			return app.utils.pad(v, 2) + ":" + ((r % 2) == 0 ? "00" : "30");
		} else {
			return "";
		}
	}

	// Funzione per sincronizzare il timestamp del dispositivo con quello del
	// cellulare
	function syncTime(time) {
		app.f7.hideIndicator();
		app.f7.showIndicator();
		if (time == undefined || time.d == undefined || time.m == undefined || time.y == undefined || time.h == undefined || time.i == undefined) {
			return;
		}

		var d_c = new Date(time.m + "/" + time.d + "/" + time.y + " " + time.h + ":" + time.i), t_c = d_c.getTime(), t_j = Math.floor(Date.now() / 1000);

		if (t_c == "NaN") {
			// La conversione in timestamp della data indica che è malformata
			return;
		}
		t_c = Math.floor(t_c / 1000);

		// 
		/*
		 * Aggiunto l'offeset relativo al timezone delle mie impostazioni
		 * 
		 * NB: devo aggiungere l'inverso di getTimezoneOffset()*60, vedi
		 * documentazione:
		 * 
		 * http://www.w3schools.com/jsref/jsref_gettimezoneoffset.asp The
		 * getTimezoneOffset() method returns the time difference between UTC
		 * time and local time, in minutes. For example, If your time zone is
		 * GMT+2, -120 will be returned.
		 * 
		 */
		t_j += (d_c.getTimezoneOffset() * -1 * 60);

		// Se si discostano di più di 5 minuti
		if (Math.abs(t_c - t_j) > 300) {
			var tz = jstz.determine();
			var timezone = tz.name();
			app.utils.ajaxRequest("POST", app.utils.GetRisorsa("time"), {
				callback : function(data) {
					if (data.success == true) {
						loadStatus({
							syncTime : false
						});
					} else {
						app.f7.addNotification({
							title : Template7.global.lbl.ERROR + ": " + data.error,
							hold : 2000
						});
					}
				},
				data : {
					value : t_j,
					tz : timezone
				},
				extraData : "calendar"
			});
		}
	}

	function loadStatus(parameters) {
		if (parameters == undefined) {
			parameters = {};
		}
		if (parameters.syncTime == undefined) {
			parameters.syncTime = true;
		}
		if (parameters.skipNotification == undefined) {
			parameters.skipNotification = false;
		}

		app.utils.getStatus({
			callback_success : function(data) {
				// Se il setup non è definito (ad esempio device resettato
				// chiamo la checkSetup
				if (data.setup == undefined || data.setup.serial == undefined || data.setup.serial == "" || data.setup.name == undefined || data.setup.name == "") {
					// Chiamo la checkSetup
					app.utils.checkSetup(app);
					return;
				}

				// Se il timestamp differisce di almeno 5 minuti
				if (parameters.syncTime) {
					syncTime(data.time);
				}

				if (data.RESULT != undefined) {
					// Calendario
					data.RESULT.nextCalendarChangeHour = getCalendarHour(data.RESULT.ncc);

					// ccv
					if (data.RESULT.currentCalendarValue != undefined) {
						data.RESULT.ccv = data.RESULT.currentCalendarValue;
					}
					
					// salvo l'IP del device corrente in caso di cloud
					var cur_dev = app.utils.getCurrentDevice();
					if(data.net != undefined && data.net.ip != undefined) {
						cur_dev.setIP(data.net.ip);
						cur_dev.save(app);
					}

					// giorno prossima cambiamento (ncc)
					data.RESULT.ncc_g = Template7.global.lbl["DAY_" + Math.floor(data.RESULT.ncc / 48)];

					// Visualizzo i dati
					showStatus(data);
				}
			},
			callback_error : function(error) {
				app.f7.addNotification({
					title : Template7.global.lbl.ERROR + ": " + error,
					hold : 2000
				});
				app.f7.hideIndicator();
				app.f7.hidePreloader();
			},
			callback_ajax_error : function(error) {
				app.f7.hideIndicator();
				app.f7.hidePreloader();

				app.utils.checkSetup(app);
			},
			syncTime : parameters.syncTime,
			skipNotification : parameters.skipNotification
		});
	}

	function showStatus(data) {
		data.RESULT.workingModeName = app.utils.getWorkingMode(data.RESULT.wm);
		data.RESULT.modeName = Template7.global.lbl[data.RESULT.workingModeName.toUpperCase()];

		// time leading zeros TODO
		data.time.d = app.utils.pad("" + data.time.d, 2);
		data.time.h = app.utils.pad("" + data.time.h, 2);
		data.time.m = app.utils.pad("" + data.time.m, 2);
		data.time.i = app.utils.pad("" + data.time.i, 2);

		data.RESULT.active = 1;
		data.RESULT.CP_active = 0;
		if(data.RESULT.ps == 0) {
			data.RESULT.active = 0;
		}
		
		// Allarmi
		if (data.RESULT.a != undefined && data.RESULT.a.length > 0) {
			if(app.utils.inArray("CP", data.RESULT.a)) {
				data.RESULT.CP_active = 1;
				data.RESULT.active = 0;
			}
			data.RESULT.alarm_string = data.RESULT.a.join(",");
		}

		if (data.RESULT.ps == 0) {
			// OFF
			$('.power-button').attr('k_value', 0).addClass("set-mode").removeClass("in-standby");
			$('.power-button i').removeClass("icon-power-1").addClass("icon-power-0");
			
			if(data.RESULT.CP_active == 1) {
				$('.power-button').removeClass("set-mode").addClass("in-standby");
			}
		} else {
			// ON
			$('.power-button').attr('k_value', 1).addClass("set-mode").removeClass("in-standby");
			$('.power-button i').removeClass("icon-power-0").addClass("icon-power-1");
			
			if(data.RESULT.CP_active == 1) {
				$('.power-button i').addClass("icon-power-0").removeClass("icon-power-1")
				$('.power-button').removeClass("set-mode").addClass("in-standby");
			}
		}
		
		// Se le parole hanno degli spazi allora applico gli a capo altrimenti l'ellipsis
		if(Template7.global.lbl.FAN_SPEED.indexOf(' ') == -1) {
			data.RESULT.fanSpeedEllipsis = true;
		}
		if(Template7.global.lbl.WEEK_PROGRAM.indexOf(' ') == -1) {
			data.RESULT.weekProgramEllipsis = true;
		}
		if(Template7.global.lbl.FLOW_DIRECTION.indexOf(' ') == -1) {
			data.RESULT.flowDirectionEllipsis = true;
		}		
		if(Template7.global.lbl.NIGHTMODE.indexOf(' ') == -1) {
			data.RESULT.nightmodeEllipsis = true;
		}
		
		dev = data.RESULT;

		var device = app.utils.getCurrentDevice();

		View.render({
			bindings : bindings_s,
			model : data,
			setup_name : device.name
		});

		if (data.RESULT.a != undefined && data.RESULT.a.length > 0) {
			$('.fn-alarm').removeClass("hidden");
		}
		
		// Versione app
		$('.version-app .app .app-ver').html(Template7.global.appVersion);
		$('.version-app .app .app-fir').html(data.sw.V);

		app.f7.hideIndicator();
		app.f7.hidePreloader();
	}

	function showModes() {
		if(dev.CP_active == 1) { // Allarme CP
			inStandby();
		} else {
			app.router.load('mode', {});
		}
	}

	function showCalendar() {
		var current_device = app.utils.getCurrentDevice();
		if (current_device.getStandalone() == false) {
			// Connected, vado al calendario
			app.router.load('calendar', {});
		} else {
			// Standalone, vado alla configurazione per andare in modalità 'connected'
			app.router.load('networks', {
				standalone : true
			});
		}
	}

	function showNetworks() {
		app.router.load('networks', {});
	}

	function showHomepage() {
		app.router.load('homepage', {});
	}

	function showMyDevices() {
		app.router.load('devices', {
			menu : true
		});
	}

	function showAdvanced() {
		app.router.load('advanced', {});
	}

	function showFeedback() {
		app.f7.modal({
			title : Template7.global.lbl.FEEDBACK,
			text : "Scrivi un commento oppure dacci un feedback relativo all'app",
			afterText : '<div class="item-input"><textarea id="feedback_text" style="resize: none" rows="3" cols="27"></textarea></div>',
			buttons : [ {
				text : Template7.global.lbl.MODAL_BUTTON_CANCEL,
				bold : false
			}, {
				text : Template7.global.lbl.MODAL_BUTTON_OK,
				bold : true,
				onClick : function() {
					var feedback = app.$$('#feedback_text').val();
					if (feedback != "") {
						app.utils.ajaxRequest("POST", app.utils.GetRisorsa("feedback"), {
							callback : function(data) {
								if (data.success == true) {
									app.f7.addNotification({
										title : Template7.global.lbl.FEEDBACK_SUCCESSFUL,
										hold : 2000
									});
								} else {
									app.f7.addNotification({
										title : Template7.global.lbl.ERROR + ": " + data.error,
										hold : 2000
									});
								}
							},
							callback_error : function(jqXHR, textStatus, errorThrown) {
								app.f7.addNotification({
									title : Template7.global.lbl.ERROR + ": " + jqXHR.statusText,
									hold : 2000
								});
							},
							data : {
								text : feedback
							}
						});
					}
				}
			} ]
		});
	}

	function showManual() {
		var url = Template7.global.lbl.MANUAL_URL;
		
		app.utils.WindowOpen(url, '_blank');
	}

	function showPreferences() {
		var language = app.utils.getLocalConfig("language"), push_notification = app.utils.getLocalConfig("push_notification");
		app.router.load('preferences', {
			language : language,
			push_notification : (push_notification == true || push_notification == "true") ? true : false,
			back : true
		});
	}
	
	function showLabels() {
		app.router.load('labels', {});
	}

	function showAlarms() {
		var alarms = $(this).attr('k_val').split(","), content = "";

		alarms.forEach(function(a) {
			content += '<div class="card">' + '<div class="card-content">' + '<div class="card-content-inner">' + Template7.global.lbl[a] + '</div>' + '</div>' + '</div>';
		});

		app.f7.alert(content, Template7.global.lbl.ALARMS);
	}

	function inStandby() {
		if(dev.CP_active == 1) {
			app.f7.alert(Template7.global.lbl.FUNCTIONALITY_AVAILABLE_DEVICE_CP, function() {});
		} else {
			app.f7.alert(Template7.global.lbl.FUNCTIONALITY_AVAILABLE_DEVICE_ON, function() {});
		}
	}
	
	function setMode() {
		app.f7.showIndicator();
		
		var call = $(this).attr("k_call"), 
			value = $(this).attr("k_value"), 
			operation = $(this).attr("k_operation") || "add";
		
		app.utils.setMode(call, value, operation, {
			callback_success : function(data) {
				if (Template7.global.testVersion == true) {
					app.f7.addNotification({
						title : app.utils.getNextMode(call, app.utils.setNextMode(call, value, operation)),
						hold : 2000
					});
					app.f7.hideIndicator();
				}

				setTimeout(function() {
					loadStatus();
				}, 500);
			},
			callback_error : function(error) {
				app.f7.addNotification({
					title : Template7.global.lbl.ERROR + ": " + error,
					hold : 2000
				});
				app.f7.hideIndicator();
			}
		});
	}

	return {
		init : init,
		refreshStatus : refreshStatus
	};
});