define([ "app", "js/models/deviceModel", "text!js/intro/prerender.html", "js/intro/introView" ], function(app, DeviceModel, Template, View) {
	var bindings = [ {
		element : '#iniziamo',
		event : 'click',
		handler : loadIntro2
	}, {
		element : '#test',
		event : 'click',
		handler : setTestVersion
	}, {
		element : '#utente_locale',
		event : 'click',
		handler : setLocalUser
	} ];
	var device = {};
	function init(parameters) {
		app.utils.Log("INIT introController");

		device = parameters.device;

		var compiled_template = Template7.compile(Template);
		var html = '<div class="popup">' + compiled_template({}) + '</div>';

		app.mainView.router.loadPage({
			content : html
		});

		View.render({
			bindings : bindings
		});

		app.utils.googleAnalytics('send', 'pageview', {
			'page' : 'intro'
		});

		setTimeout(function() {
			app.f7.hidePreloader();
			app.f7.hideIndicator();
			//$('.screensaver').hide();
		}, 500);
	}

	function loadIntro2() {
		if (app.utils.isPhoneGap()) {
			app.utils.networkConnection({
				SSID : Template7.global.ESSID_default,
				app : app
			});
		} else {
			app.f7.showPreloader(Template7.global.lbl.COMMUNICATION_DEVICE);
			app.utils.ajaxRequest("GET", app.utils.GetRisorsa("status"), {
				callback : function(data) {
					app.f7.hidePreloader();
					if (data.success == true) {
						if (data.setup == undefined || data.setup.serial == undefined || data.setup.serial == "" || data.setup.name == undefined || data.setup.name == "") {
							app.router.load('setup', {
								device : device
							});
						} else {
							var dev = {
								"UID" : data.UID,
								"preferred" : true,
								"name" : data.setup.name,
								"serial" : data.setup.serial,
								"standalone" : (data.RESULT.ns == 1) ? true : false
							};
							var dev2_save = app.utils.getDeviceModel(dev);

							// Aggiungo/Aggiorno il dispositivo all'elenco dei
							// dispositivi
							dev2_save.save(app);

							// Imposto come dispositivo corrente
							app.utils.setCurrentDevice(dev2_save);
							app.router.load('homepage');
						}
					} else {
						app.router.load('modal', {
							title : Template7.global.lbl.WARNING,
							message : Template7.global.lbl.CONFIGURATION_ERROR,
							buttons : {
								reload : true,
								devices : true
							}
						});
					}
				},
				extraData : "intro",
				callback_error : function(jqXHR, textStatus, errorThrown) {
					app.f7.hidePreloader();
					
					app.router.load('modal', {
						title : Template7.global.lbl.WARNING,
						message : Template7.global.lbl.SEEMS_NOT_CONNECTED + ": <b>" + Template7.global.ESSID_default + "</b></br>" + Template7.global.lbl.WHEN_CONNECTED,
						buttons : {
							reload : true,
							devices : true
						}
					});
				},
				skipNotification : true,
				timeout : 10000
			});
		}
	}

	function setTestVersion() {
		app.utils.setLocalConfig("testVersion", (Template7.global.testVersion == true) ? 0 : 1);
		window.location.reload();
	}

	function setLocalUser() {
		app.utils.setLocalConfig("localUser", (Template7.global.localUser == "marco") ? "moreno" : "marco");
		window.location.reload();
	}

	return {
		init : init
	};
});