define([ "app", "text!js/modal/prerender.html", "js/modal/modalView" ], function(app, Template, View) {
	var bindings = [ {
		element : '.reload',
		event : 'click',
		handler : reloadApp
	}, {
		element : '.devices',
		event : 'click',
		handler : listDevices
	} ];

	var interrupt = false, force_stop = false;
	
	function init(parameters) {
		app.utils.Log("INIT modalController");

		app.f7.showIndicator();

		var compiled_template = Template7.compile(Template);
		var html = '<div class="popup popup-modal">' + compiled_template({}) + '</div>';

		app.f7.popup(html, true);

		interrupt = false;
		force_stop = false;
		
		loadModal(parameters);

		app.utils.googleAnalytics('send', 'pageview', {
			'page' : 'modal'
		});
	}

	function loadModal(parameters) {
		showModal(parameters);
	}

	function recCheckSSID() {		
		if(!interrupt) {
			if (app.utils.checkWifi()) {
				WifiWizard.getCurrentSSID(function(ssid) {
					app.utils.Log("SSID: " + ssid);
					
					var current_device = app.utils.getCurrentDevice(),
						calculated_ssid = Template7.global.ESSID_default;
					// Se il dispositivo corrente c'è (è stato configurato) allora calcolo il suo SSID
					if(current_device !== false) {
						calculated_ssid += "_" + current_device.name;
					}
					app.utils.Log("SSID passato: " + calculated_ssid);
					
					if (calculated_ssid == ssid) {
						interrupt = true;
					}					
					setTimeout(function() {
						recCheckSSID();
					}, 5000);
				}, function(e) {
					app.utils.Log("WifiWizard.getCurrentSSID error: " + e);
					setTimeout(function() {
						recCheckSSID();
					}, 5000);
				});
			} else {
				app.utils.Log("Nessuna connessione");
				setTimeout(function() {
					recCheckSSID();
				}, 5000);
			}
		} else {
			// Faccio la check setup solo se non ho cliccato su "Dispositivi" sulla modale
			if(!force_stop) {
				app.f7.closeModal();
				app.utils.checkSetup(app);
			}			
		}
	}

	function showModal(parameters) {
		View.render({
			bindings : bindings,
			model : parameters
		});
		app.f7.hideIndicator();

		if (parameters.buttons.loop == true) {
			var container = app.$$('.loop-connection');
			if (container.children('.progressbar, .progressbar-infinite color-multi').length) {
			} else {
				app.f7.showProgressbar(container, 'multi');
			}
			// Controllo ricorsivo sull'SSID
			recCheckSSID();
		}
	}

	function reloadApp() {
		app.f7.closeModal();
		app.f7.showPreloader(Template7.global.lbl.RESTARTING_APP);
		setTimeout(function() {
			window.location.reload();
		}, 500);
	}

	function listDevices() {
		interrupt = true;
		force_stop = true;
		
		app.f7.hideIndicator();
		app.f7.closeModal();
		
		app.router.load('devices', {
			back : false
		});
	}

	return {
		init : init
	};
});