define([ "app", "js/homepage/homepageController", "text!js/mode/prerender.html", "js/mode/modeView" ], function(app, HomepageRef, Template, View) {
	var bindings = [ {
		element : '.set-mode',
		event : 'click',
		handler : setMode
	} ];

	var device = {};
	function init() {
		app.utils.Log("INIT modeController");

		app.f7.showIndicator();

		var compiled_template = Template7.compile(Template);
		var html = '<div class="popup popup-modes">' + compiled_template({}) + '</div>';

		app.f7.popup(html, true);

		loadModes(false);

		app.utils.googleAnalytics('send', 'pageview', {
			'page' : 'mode'
		});
	}

	function loadModes(refresh) {
		app.utils.ajaxRequest("GET", app.utils.GetRisorsa("status"), {
			callback : function(data) {
				if (data.success == true && data.RESULT != undefined) {
					if(data.RESULT.heatingDisabled == undefined) {
						data.RESULT.heatingDisabled = 0;
					}
					device = data.RESULT;
					showModes(data, refresh);
				} else {
					app.f7.addNotification({
						title : Template7.global.lbl.ERROR + ": " + data.error,
						hold : 2000
					});
				}
			}
		});
	}

	function showModes(data, refresh) {
		View.render({
			bindings : bindings,
			model : data
		});

		app.$$('.popup').on('close', function() {
			HomepageRef.refreshStatus();
		});
	}

	function sendMode(mode) {
		setTimeout(function() {
			app.utils.setWorkingMode(mode, {
				callback_success : function(data) {
					msg = mode;
					app.f7.closeModal();

					if (Template7.global.testVersion == true) {
						app.f7.addNotification({
							title : msg,
							hold : 2000
						});
					}
				},
				callback_error : function(error) {
					app.f7.addNotification({
						title : Template7.global.lbl.ERROR + ": " + error,
						hold : 2000
					});
				},
				app : app
			});
		}, 500);
	}

	function setMode() {
		app.f7.showIndicator();
		var mode = $(this).attr('k_custom');

		// In caso di standalone e programmazione faccio redirect al passaggio in modalità 'connected'
		var current_device = app.utils.getCurrentDevice();
		if (current_device.getStandalone() == true && mode == "set/calendar/on") {
			app.router.load('networks', {
				standalone : true
			});
			
			setTimeout(function() {
				app.f7.closeModal();
			}, 200);
			return;
		}
		
		if (device.cm == 1) {
			if (mode == "set/calendar/on") {
				showCalendar();
				
				setTimeout(function() {
					app.f7.closeModal();
				}, 1000);
			} else {
				sendMode(mode);
			}
		} else {
			sendMode(mode);
		}
	}

	function showCalendar() {
		app.router.load('calendar', {});
	}

	return {
		init : init
	};
});