define([ "app", "text!js/preferences/prerender.html", "js/preferences/preferencesView" ], function(app, Template, View) {
	var bindings = [ {
		element : '#prosegui',
		event : 'click',
		handler : loadSetup
	} ];

	var language = "", push_notification = true, back = false;
	function init(parameters) {
		app.f7.showIndicator();
		app.utils.Log("INIT preferencesController");

		if (parameters.language != undefined) {
			language = parameters.language;
		} else {
			language = Template7.global.defaultLanguage;
		}

		if (parameters.push_notification != undefined) {
			push_notification = parameters.push_notification;
		} else {
			push_notification = true;
		}

		if (parameters.back != undefined) {
			back = parameters.back;
		} else {
			back = false;
		}

		if (!back) {
			// Coloro il navpanel per avere uno sfondo uniforme
			$("#navpanel").css("background-color", "#2682ab");
		}

		var languages = new Array(),
			lang_found = false;
		Template7.global.languages.forEach(function(l) {
			languages.push({
					"key" : l,
					"label" : Template7.global.isoLangs[l].nativeName + " (" + l.toUpperCase() + ")"
			});
			if(l == language) {
				// Se la lingua passata è nelle localizzazione sono a posto
				lang_found = true;
			}
		});
		
		// Se la lingua non è presente nelle localizzazioni attivo di default l'inglese		
		if(!lang_found) {
			language = Template7.global.defaultLanguage;
		}
		
		var compiled_template = Template7.compile(Template);
		var html = '<div class="popup popup-preferences">' + compiled_template({
			model : {
				language : language,
				push_notification : push_notification,
				back : back,
				languages : languages,
				phonegap : app.utils.isPhoneGap()
			}
		}) + '</div>';

		app.f7.popup(html, true);
		
		View.render({
			bindings : bindings
		});

		app.utils.googleAnalytics('send', 'pageview', {
			'page' : 'preferences'
		});

		app.f7.hideIndicator();
		app.f7.hidePreloader();

		// Submit form
		$('#preferences').validate({
			submitHandler : function(form) {
				app.f7.closeModal();
				loadSetup();
				return false;
			}
		});
	}

	function loadSetup() {
		var push_change = ($('input[name="push_notification"]').is(":checked")) ? true : false, old_push_change = (app.utils.getLocalConfig("push_notification") == "true") ? true : false, language = $('#language').val();

		app.utils.setLocalConfig("language", language);
		app.utils.setLocalConfig("push_notification", push_change);

		// Se lo stato che scelgo è diverso dal precedente allora vado ad aggiornare il DB relativamente
		if (push_change != old_push_change) {
			app.utils.SettingsPushNotification(push_change);
		}

		app.f7.showPreloader(Template7.global.lbl.CONFIGURING_PREFERENCES);
		setTimeout(function() {
			app.f7.hidePreloader();
			window.location.reload();
		}, 2500);
	}

	return {
		init : init
	};
});