define([ 'js/models/deviceModel', 'js/models/labelModel' ], function(DeviceModel, LabelModel) {
	var f7 = {}, $$ = {}, mainView = {}, currentDevice = false, push = false, router = {}, log_ref = $('#customlog');

	var checkWifiMaxErrors = 0;
	var checkWifiErrors = 0;

	function checkConnection() {
		var connected = getLocalConfig("connected");

		if (connected == "true") {
			return true;
		} else {
			return false;
		}
	}

	function setRouter(Router) {
		router = Router;
	}

	function checkWifi() {
		if (checkConnection()) {
			if (isPhoneGap() && navigator.connection !== undefined) {
				var networkState = navigator.connection.type;

				if (networkState == "wifi") {
					return true;
				} else {
					return false;
				}
			} else {
				return true;
			}
		} else {
			return false;
		}
	}

	function isPhoneGap() {
		var app = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;
		if (app) {
			return true;
		} else {
			return false;
		}
	}

	function getAppLabels(lingua) {
		Log("Lingua trovata: " + lingua);
		if (lingua == "" || !inArray(lingua, Template7.global.languages)) {
			lingua = "en";
		}
		var path = "js/localization/" + lingua + ".js";

		$.ajax({
			url : path,
			dataType : "script",
			async : false,
			success : function(data) {
				Template7.global.lbl = lbl;
			}
		});
	}

	function inArray(needle, haystack) {
		var length = haystack.length;
		for (var i = 0; i < length; i++) {
			if (haystack[i] == needle)
				return true;
		}
		return false;
	}

	// esci dall'app
	function exitFromApp() {
		navigator.app.exitApp();
	}

	function WindowOpen(url) {
		if (url != "" && url != undefined) {
			f7.showIndicator();
			window.open(url, '_blank', 'location=no,closebuttoncaption=Chiudi,enableViewportScale=no');
			googleAnalytics('send', 'event', 'href click', url);
			f7.hideIndicator();
		}
	}

	// set dell'app per riferimenti globali
	function setApp(f7_ref, Dom7_ref, mainView_ref) {
		f7 = f7_ref;
		$$ = Dom7_ref;
		mainView = mainView_ref;
	}

	// popup uscita app
	function exitAppPopup() {
		navigator.notification.confirm('Vuoi uscire da questa applicazione?', function(button) {
			if (button == 2) {
				navigator.app.exitApp();
			}
		}, 'Attenzione!', 'No,Sì');
		return false;
	}

	function setLocalConfig(Key, Value, parameters) {
		if(parameters === undefined) {
			parameters = {};
		}
		
		if (window.device == undefined || window.device.platform != "iOS") {
			Log("setLocalConfig [" + Key + "]=" + Value);
		}

		localStorage[Key] = Value;
		
		if(!isPhoneGap()) {
			if(parameters.no_ajax == undefined || parameters.no_ajax == false) {
				setLocalStorage(Key, Value);
			}			
		}
	}
	
	function setLocalStorage(Key, Value) {
		if(Template7.global.localTest === true) {
			return;
		}
		
		ajaxRequest("POST", GetRisorsa("localstorage_set"), {
			callback : function(data) {
				if (data.success == true) {
					
				}
			},
			callback_error : function(jqXHR, a, b) {
				Log("Errore: " + jqXHR.statusText);
			},
			data : {
				key : Key,
				value : Value
			},
			skipNotification : true
		});
	}
	
	function syncLocalStorage(parameters) {
		if(parameters == undefined) {
			parameters = {};
		}
		
		if(Template7.global.localTest === true) {
			if(parameters.callback != undefined) {
				parameters.callback({});
				return;
			}		
		}
		
		ajaxRequest("GET", GetRisorsa("localstorage_get"), {
			callback : function(data) {
				if (data.success == true && data.RESULT != undefined) {
					Object.keys(data.RESULT).forEach(function(key) {
						setLocalConfig(key, data.RESULT[key], {
							no_ajax : true
						});
					});
				} else {
					Log("Errore: " + data.error);
				}
				
				if(parameters.callback != undefined) {
					parameters.callback(data);
				}
			},
			callback_error : function(jqXHR, a, b) {
				Log("Errore: " + jqXHR.statusText);
				
				f7.addNotification({
					title : jqXHR.statusText,
					hold : 2000
				});
			},
			skipNotification : true
		});
	}

	function getLocalConfig(Key, parameters) {
		if (parameters === undefined) {
			parameters = {};
		}
		if (window.device == undefined || window.device.platform != "iOS") {
			Log("getLocalConfig [" + Key + "]=" + localStorage[Key]);
		}

		if (localStorage[Key] === undefined && parameters.defaultValue !== undefined) {
			Log("getLocalConfig [" + Key + "] is not set, setting defaultValue=" + parameters.defaultValue);
			return parameters.defaultValue;
		} else {

			/*
			 * in caso di stringa false forzo un risultato boolean
			 */
			if (localStorage[Key] == "false") {
				return false;
			}

			return localStorage[Key];
		}
	}

	function unsetCurrentDevice() {
		currentDevice = false;
	}

	function getUrlApp(parameters) {
		if(parameters == undefined) {
			parameters = {};
		}
		if(parameters.device == undefined) {
			parameters.device = false;
		}
		
		var device;
		if(parameters.device !== false) {
			device = parameters.device;
		} else {
			device = getCurrentDevice();
		}
		
		if (device != false) {
			$url = device.getUrl();
		} else {
			$url = getLocalConfig("urlApp", {
				defaultValue : Template7.global.defaultUrl
			});
		}
		return $url;
	}

	function GetRisorsa(TipoRisorsa, parameters) {
		// Log("Tipo Risorsa: " + TipoRisorsa);
		if (parameters == undefined) {
			parameters = {};
		}
		if (parameters.device == undefined) {
			parameters.device = false;
		}

		var path = "";
		if (parameters.url != undefined) {
			path = parameters.url;
		} else {
			path = getUrlApp(parameters);
		}
		
		if(Template7.global.localTest === true) {
			path = Template7.global.defaultUrl;
		}

		switch (TipoRisorsa) {
		case "status":
			path += "status";
			break;
		case "status_advanced":
			var cur_dev = getCurrentDevice();
			if (cur_dev != false) {
				path = "http://" + cur_dev.getIP() + "/api/v/1/status";
			}
			break;
		case "calendar":
			path += "calendar/program";
			break;
		case "time":
			path += "set/time";
			break;
		case "setup":
			path += "setup";
			break;
		case "network_scan":
			path += "network/scan";
			break;
		case "network_set":
			path += "network/set";
			break;
		case "network_set_advanced":
			if (isPhoneGap()) {
				var cur_dev = getCurrentDevice();
				if (cur_dev != false) {
					path = "http://" + cur_dev.getIP() + "/api/v/1/network/set";
				}
			} else {
				path = Template7.global.defaultUrl + "/network/set";
			}
			break;
		case "setup_advanced":
			if (isPhoneGap()) {
				var cur_dev = getCurrentDevice();
				if (cur_dev != false) {
					path = "http://" + cur_dev.getIP() + "/api/v/1/setup";
				}
			} else {
				path = Template7.global.defaultUrl + "setup";
			}
			break;
		case "connection":
			path += "connection";
			break;
		case "waitfordevice":
			path += "waitfordevice";
			break;
		case "push":
			path += "push";
			break;
		case "push_delete":
			path += "push_delete";
			break;
		case "push_settings":
			path += "push_settings";
			break;
		case "feedback":
			path += "feedback";
			break;
		case "localstorage_set":
			if (!isPhoneGap()) path = "";
			path += "localstorage/set";
			break;
		case "localstorage_get":
			if (!isPhoneGap()) path = "";
			path += "localstorage/get";
			break;
		default:
			break;
		}
		// Log("URL: " + path);
		return path;
	}

	function Log(message) {
		// TODO temporaneo
		if (isPhoneGap()) {
			if (window.device != undefined && window.device.platform == "iOS") {
				console.log(message);
				// alert(message);
			} else {
				console.log(message);
			}
		} else {
			console.log(message);
		}

		/*
		 * var element = document.createElement("p");
		 * 
		 * var str_to_print = ""; if (typeof message === 'object') {
		 * str_to_print = JSON.stringify(message); } else { str_to_print =
		 * message; }
		 * element.appendChild(document.createTextNode(str_to_print));
		 * 
		 * try { // ripulisco dom if (log_ref.html().length > 2500)
		 * log_ref.html("reset"); log_ref.prepend(element); } catch (Exception) { }
		 */
	}

	function noConnectionModal(parameters) {
		f7.hidePreloader();
		f7.hideIndicator();

		if (parameters == undefined) {
			parameters = {};
		}

		var message = "", dev = getCurrentDevice();

		if (dev != false) {
			if (dev.getStandalone() == true) {
				// standalone
				message = Template7.global.lbl.SEEMS_NOT_CONNECTED + ": <b>" + Template7.global.ESSID_default + "_" + dev.name + "</b></br>" + Template7.global.lbl.WHEN_CONNECTED;
			} else {
				// cloud
				message = Template7.global.lbl.DEVICE_NOT_REACHABLE + ".<br/>" + Template7.global.lbl.VERIFY_CONNECTION + " " + Template7.global.lbl.DEVICE_FUNCTIONAL + ".";
			}
		} else {
			// non configurato
			message = Template7.global.lbl.SEEMS_NOT_CONNECTED + ": <b>" + Template7.global.ESSID_default + "</b></br>" + Template7.global.lbl.WHEN_CONNECTED;
		}

		router.load('modal', {
			title : Template7.global.lbl.WARNING,
			loop_message : Template7.global.lbl.WAITING_LIVE_CONNECTION,
			message : message,
			buttons : {
				loop : (isPhoneGap() && window.device != undefined && window.device.platform == "iOS") ? true : false,
				reload : true,
				devices : true
			}
		});
	}

	function ajaxRequest(type, url, parameters) {
		var device = getCurrentDevice();

		if (type == undefined || type == "") {
			type = "GET";
		}
		if (parameters.data == undefined) {
			parameters.data = {};
		}
		if (parameters.crossDomain == undefined) {
			parameters.crossDomain = false;
		}
		if (parameters.async == undefined) {
			parameters.async = true;
		}
		if (parameters.timeout == undefined) {
			parameters.timeout = 20000;
		}
		if (parameters.returnObject == undefined) {
			parameters.returnObject = false;
		}
		if (parameters.skipNotification == undefined) {
			parameters.skipNotification = false;
		}
		if (parameters.waitRequest == undefined) {
			parameters.waitRequest = false;
		}
		if (parameters.device !== undefined && parameters.device !== false) {
			device = parameters.device;
		}
		
		var headers = {
			'X-UID' : device.UID,
			'X-serial' : device.serial
		};
		
		// Desktop
		if(!isPhoneGap()) {
			if(Template7.global.localTest === true) {
				// Non faccio nulla
			} else {
				var a = document.createElement('a')
				a.href = url;
				var ip = a.hostname;
				
				url = url.replace(ip, "127.0.0.1:"+document.location.port);
				headers['X-Proxy-Host'] = ip; //ip;
				headers['X-Proxy-Timeout'] = parameters.timeout;
			}			
		}
		

		var ajax_object = {
			method : type,
			extraData : parameters.custom_parameter,
			url : url,
			dataType : "json",
			timeout : parameters.timeout,
			async : parameters.async,
			crossDomain : parameters.crossDomain,
			headers : headers,
			data : parameters.data,
			beforeSend : function(xhr, opts) {
				// Se non sono connesso ad internet do un errore
				if (!checkConnection() && !parameters.waitRequest) {
					xhr.abort();
					noConnectionModal();
				}

				// Se sono connesso ma non sono in cloud devo essere connesso ad
				// una rete di tipo WIFI
				if (opts.extraData != "cloud" && this.url.indexOf(Template7.global.defaultUrlCloud) == -1) {
					if (!checkWifi()) {
						if (!parameters.waitRequest) {
							if (checkWifiErrors > checkWifiMaxErrors) {
								xhr.abort();
								noConnectionModal();
							} else {
								checkWifiErrors++;
								xhr.abort();
								ajaxRequest(type, url, parameters);
							}
						}
					} else {
						checkWifiErrors = 0;
					}
				}
			},
			success : function(data) {
				if(parameters.callback !== undefined) {
					parameters.callback(data);
				}
				if(parameters.callback_success !== undefined) {
					parameters.callback_success(data);
				}
			},
			error : function(jqXHR, textStatus, errorThrown) {
				if (parameters.callback_error != undefined) {
					parameters.callback_error(jqXHR, textStatus, errorThrown);
				}
				if (!parameters.skipNotification) {
					f7.addNotification({
						title : Template7.global.lbl.ERROR + ": " + jqXHR.statusText,
						hold : 2000
					});
				}
			}
		};

		if (parameters.extraData != undefined) {
			ajax_object.extraData = parameters.extraData;
		}

		if (parameters.returnObject == true) {
			return ajax_object;
		}

		$.ajax(ajax_object);
	}

	function RegisterPushNotification() {
		if(isPhoneGap()) {
			return;
		}
		
		try {
			var devices = getDevices();
			if (devices == false) {
				// Se non ci sono dispositivi non registor le notifiche PUSH
				return;
			} else {
				var dev_standalone = false;
				for (key in devices) {
					if (devices[key].standalone == false) {
						dev_standalone = true;
					}
				}
				if (!dev_standalone) {
					// Se non ci sono dispositivi standalone evito di registrare
					// le notifiche PUSH
					return;
				}
			}

			ajaxRequest("GET", GetRisorsa("connection", {
				url : Template7.global.defaultUrlCloud
			}), {
				callback : function(data) {
					if (data.success == true) {
						var notification_id = getLocalConfig("notification_id");

						Log("Notification ID attuale: " + notification_id);

						if (device.platform == "Android") {
							push = PushNotification.init({
								"android" : {
									"senderID" : "827647688308",
									"icon" : "icon",
									"iconColor" : "#2682AB"
								}
							});
						} else if (device.platform == "iOS") {
							push = PushNotification.init({
								"ios" : {
									"alert" : "true",
									"badge" : "true",
									"sound" : "true"
								}
							});
						} else if (device.platform == "WinCE" || device.platform == "Win32NT") {
							push = PushNotification.init({
								"windows" : {}
							});
						}

						push.on('registration', function(data) {
							setLocalConfig("notification_id", data.registrationId);
							Log("pushNotification succesfully registered: " + data.registrationId);

							for (key in devices) {
								// Solo per i device di tipo "connected"
								// (standalone = false)
								if (devices[key].standalone == false) {
									SetPushNotification(devices[key].UID);
								}
							}
						});

						// Listener notifiche
						push.on('notification', function(data) {
							if (data != undefined && data.additionalData != undefined && data.additionalData.customdata != undefined && data.additionalData.customdata.uid != undefined) {
								Log(data);
								var dev = getDeviceByUID(data.additionalData.customdata.uid);
								if (dev != false) {
									setCurrentDevice(dev);

									// Foreground
									if (data.additionalData.foreground == true) {
										// Notifica inline
										f7.addNotification({
											title : data.message,
											hold : 5000,
											closeOnClick : true,
											onClick : function() {
												router.load('homepage', {});
											}
										});
									} else {
										// Coldstart
										if (data.additionalData.coldstart == undefined) { // iOS
											window.location.reload();
										} else if (data.additionalData.coldstart == true) { // Android
											window.location.reload();
										} else {
											router.load('homepage', {});
										}
									}
								}
							}
						});

						// Listener errori
						push.on('error', function(e) {
							f7.addNotification({
								title : Template7.global.lbl.ERROR + ": " + e.message,
								hold : 3000
							});
						});
					}
				},
				extraData : "cloud",
				callback_error : function(jqXHR, a, b) {
					Log("Errore: " + jqXHR.statusText);
					// Non posso registrare le notifiche PUSH
				},
				skipNotification : true,
				crossDomain : true
			});
		} catch (error) {
			Log("Errore: " + error);
		}
	}

	function SetPushNotification(device_id) {
		if(isPhoneGap()) {
			return;
		}
		var notification_id = "8H2RtN4cULrsT75PFffsk8TK53Fn9nyhp6vDzAvkwp5KmD28", platform = "webOS", phone_id = "test_webOS";

		if (device_id == undefined || device_id == "") {
			var dispositivo = getCurrentDevice();
			device_id = dispositivo.UID;
		}

		ajaxRequest("POST", GetRisorsa("push"), {
			callback : function(data) {
				if (data.success == true) {
					f7.addNotification({
						title : Template7.global.lbl.PUSH_NOTIFICATIONS_ENABLED,
						hold : 3000
					});
				} else {
					f7.addNotification({
						title : Template7.global.lbl.ERROR + ": " + data.error,
						hold : 2000
					});
				}
			},
			data : {
				notification_id : notification_id,
				device_id : device_id,
				device_type : platform,
				phone_id : phone_id
			}
		});
	}

	function SettingsPushNotification(status) {
		if(isPhoneGap()) {
			return;
		}
		var phone_id = getLocalConfig("phone_id");

		ajaxRequest("POST", GetRisorsa("push_settings"), {
			callback : function(data) {
				if (data.success == true) {
					f7.addNotification({
						title : (status == true) ? Template7.global.lbl.PUSH_NOTIFICATIONS_ENABLED : Template7.global.lbl.PUSH_NOTIFICATIONS_DISABLED,
						hold : 3000
					});
				} else {
					f7.addNotification({
						title : Template7.global.lbl.ERROR + ": " + data.error,
						hold : 2000
					});
				}
			},
			data : {
				enabled : (status == true) ? 1 : 0,
				phone_id : phone_id
			}
		});
	}

	function DeletePushNotification(device_id) {
		if(isPhoneGap()) {
			return;
		}
		var phone_id = getLocalConfig("phone_id");

		if (device_id == undefined || device_id == "") {
			var dispositivo = getCurrentDevice();
			device_id = dispositivo.UID;
		}

		ajaxRequest("POST", GetRisorsa("push_delete"), {
			callback : function(data) {
				if (data.success == true) {
					f7.addNotification({
						title : Template7.global.lbl.PUSH_NOTIFICATIONS_DELETED,
						hold : 3000
					});
				} else {
					f7.addNotification({
						title : Template7.global.lbl.ERROR + ": " + data.error,
						hold : 2000
					});
				}
			},
			data : {
				device_id : device_id,
				phone_id : phone_id
			}
		});
	}

	function googleAnalytics(type, object, name, message) {
		$('.button.close-notification').html();
		
		if (checkConnection() == true) {
			if (object == "event") {
				ga(type, object, name, message, '');
			}
			if (object == "pageview") {
				ga(type, object, name.page);
			}
		}
	}

	function getDevices() {
		var devices_json = getLocalConfig("devices");
		if (devices_json != undefined) {			
			var temp_devices = JSON.parse(devices_json),
				devices = {};
			Object.keys(temp_devices).forEach(function (key) {
				devices[key] = getDeviceModel(temp_devices[key]);
			});
			return devices;
		} else {
			return false;
		}
	}

	function deleteDevice(uid, app) {
		if (uid != undefined && uid != "") {
			var devices = getDevices();
			if (devices != false) {
				if (devices[uid] != undefined) {
					if (devices[uid].standalone == false) {
						// Dispositivo "connected", rimuovo le notifiche PUSH
						DeletePushNotification(uid);
					}
					// Rimuovo il dispositivo dal localStorage
					delete devices[uid];

					// Imposto il nuovo preferito se c'è almeno un device
					if (Object.keys(devices).length > 0) {
						devices[Object.keys(devices)[0]].preferred = true;

						saveDevices(devices);
					} else {
						saveDevices(devices);
						currentDevice = false;
						// Ricarico l'app
						window.location.reload();
					}
				}
			}
		}
	}

	function saveDevices(devices) {
		if (devices != false) {
			if(currentDevice !== false) {
				Object.keys(devices).forEach(function (key) {
					if(key == currentDevice.UID) {
						currentDevice = getDeviceModel(devices[key]);
					}
				});
			}			
			setLocalConfig("devices", JSON.stringify(devices));
		}
	}

	function getDeviceModel(payload) {
		var new_device = new DeviceModel();
		new_device.load(payload);
		return new_device;
	}

	function getDeviceByUID(UID) {
		var devices = getDevices();
		if (devices !== false) {
			if (devices[UID] != undefined) {
				return getDeviceModel(devices[UID]);
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function saveDevice(device) {
		var devices = getDevices();
		if (device == undefined || device.UID == undefined) {
			Log("Device is undefined or malformed");
			return false;
		}
		if (devices == false) {
			devices = {};
		}

		devices[device.UID] = device;
		saveDevices(devices);
	}

	function setCurrentDevice(device) {
		if (device != undefined) {
			currentDevice = device;
		}
	}

	function setPreferredDevice(UID) {
		var devices = getDevices();
		if (devices !== false) {
			for (key in devices) {
				if (devices[key].UID == UID) {
					devices[key].preferred = true;
				} else {
					devices[key].preferred = false;
				}
			}
			saveDevices(devices);
		} else {
			return false;
		}
	}

	function getCurrentDevice() {
		return currentDevice;
	}

	function getPreferredDevice() {
		var devices = getDevices();
		if (devices !== false) {
			for ( var key in devices) {
				if (devices[key].preferred) {
					return getDeviceModel(devices[key]);
				}
			}
			return false;
		} else {
			return false;
		}
	}

	function replaceAt(s, n, t) {
		return s.substring(0, n) + t + s.substring(n + 1);
	}

	function findIP(callback) {
		var ip_address = "";
		if (typeof cordova != 'undefined') { // app
			networkinterface.getIPAddress(function(ip) {
				callback(ip);
			});
		} else { // browser
			window.RTCPeerConnection = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection; // compatibility
			// for
			// firefox
			// and
			// chrome
			var pc = new RTCPeerConnection({
				iceServers : []
			}), noop = function() {
			};
			pc.createDataChannel(""); // create a bogus data channel
			pc.createOffer(pc.setLocalDescription.bind(pc), noop); // create
			// offer and
			// set local
			// description
			pc.onicecandidate = function(ice) { // listen for candidate events
				if (!ice || !ice.candidate || !ice.candidate.candidate)
					return;
				var myIP = /([0-9]{1,3}(\.[0-9]{1,3}){3}|[a-f0-9]{1,4}(:[a-f0-9]{1,4}){7})/.exec(ice.candidate.candidate)[1];
				pc.onicecandidate = noop;

				callback(myIP);
			};
		}
	}

	function checkSetup(app, parameters) {
		f7.hidePreloader();
		f7.showPreloader(Template7.global.lbl.CHECK_DEVICE);

		if (parameters === undefined) {
			parameters = {};
		}
		if (parameters.counter === undefined) {
			parameters.counter = 0;
		}

		parameters.counter++;

		ajaxRequest("GET", GetRisorsa("status"), {
			timeout : 5000,
			callback : function(data) {
				if (data.success == true) {
					// Se è già stato configurato il setup
					if (data.setup == undefined || data.setup.serial == undefined || data.setup.serial == "" || data.setup.name == undefined || data.setup.name == "") {
						f7.hidePreloader();
						// Carico il setup
						router.load('setup', {});
					} else {
						device = getDeviceByUID(data.UID);
						if (device == false) {
							device = new DeviceModel();
						}

						device.setName(data.setup.name);
						device.setSerial(data.setup.serial);
						device.setUID(data.UID);
						if (data.RESULT != undefined && data.RESULT.ns != undefined) {
							device.setStandalone((data.RESULT.ns == 1) ? true : false);
						} else {
							device.setStandalone(true);
						}

						// Aggiungo/Aggiorno il dispositivo all'elenco dei
						// dispositivi
						device.save(app);

						setCurrentDevice(device);

						// Carico la homepage
						setTimeout(function() {
							f7.hidePreloader();
							router.load('homepage', {});
						}, 2000);
					}
				} else {
					// success = false, errore, riavviare l'app
					f7.hidePreloader();
					router.load('modal', {
						title : Template7.global.lbl.ERROR,
						message : Template7.global.lbl.RETRY,
						buttons : {
							reload : true
						}
					});
				}
			},
			callback_error : function(jqXHR, textStatus, errorThrown) {

				if (parameters.counter > 4) {

					var current_device = getCurrentDevice();
					f7.hidePreloader();

					if (current_device === false) {
						// Non ho nessun device preferito, primo avvio dell'app
						router.load('modal', {
							title : Template7.global.lbl.WARNING,
							message : Template7.global.lbl.SEEMS_NOT_CONNECTED + ": <b>" + Template7.global.ESSID_default + "</b></br>" + Template7.global.lbl.WHEN_CONNECTED,
							loop_message : Template7.global.lbl.WAITING_LIVE_CONNECTION,
							buttons : {
								loop : (isPhoneGap() && window.device != undefined && window.device.platform == "iOS") ? true : false,
								reload : true,
								devices : true
							}
						});
					} else {
						if (current_device.standalone == true) {
							router.load('modal', {
								title : Template7.global.lbl.WARNING,
								message : Template7.global.lbl.SEEMS_NOT_CONNECTED + ": <b>" + Template7.global.ESSID_default + "_" + current_device.name + "</b></br>" + Template7.global.lbl.WHEN_CONNECTED,
								buttons : {
									reload : true,
									devices : true
								}
							});
						} else if (current_device.standalone == false) {
							// Richiesta AJAX Cloud per configurazione wifi
							f7.showPreloader(Template7.global.lbl.CONFIGURATION_IN_PROGRESS);
							
							ajaxRequest("GET", GetRisorsa("status", {
								url : Template7.global.defaultUrlCloud
							}), {
								callback : function(data) {
									if(data.success == true) {
										f7.hidePreloader();
										
										Log("Cloud in callback error checkSetup");
										
										router.load('modal', {
											title : Template7.global.lbl.WARNING,
											message : Template7.global.lbl.DEVICE_NOT_REACHABLE + ".<br/>" + Template7.global.lbl.VERIFY_CONNECTION + " " + Template7.global.lbl.DEVICE_FUNCTIONAL + ".",
											buttons : {
												reload : true,
												devices : true
											}
										});
									} else {
										f7.hidePreloader();
										
										router.load('modal', {
											title : Template7.global.lbl.WARNING,
											message : Template7.global.lbl.DEVICE_NOT_REACHABLE + ".<br/>" + Template7.global.lbl.VERIFY_CONNECTION + " " + Template7.global.lbl.DEVICE_FUNCTIONAL + ".",
											buttons : {
												reload : true,
												devices : true
											}
										});
									}
								},
								callback_error : function(jqXHR, textStatus, errorThrown) {
									f7.hidePreloader();

									router.load('modal', {
										title : Template7.global.lbl.WARNING,
										message : Template7.global.lbl.DEVICE_NOT_REACHABLE + ".<br/>" + Template7.global.lbl.VERIFY_CONNECTION + " " + Template7.global.lbl.DEVICE_FUNCTIONAL + ".",
										buttons : {
											reload : true,
											devices : true
										}
									});
								},
								extraData : "cloud",
								crossDomain : true
							});
						} else {
							router.load('modal', {
								title : Template7.global.lbl.WARNING,
								message : Template7.global.lbl.CONFIGURATION_ERROR,
								buttons : {
									reload : true
								}
							});
						}
					}

				} else {
					f7.hidePreloader();
					checkSetup(app, parameters);
				}
			},
			extraData : "setup",
			skipNotification : true
		});
	}

	function focusField(id) {
		var inputField = document.getElementById(id);
		if (inputField != null && inputField.value.length != 0) {
			if (inputField.createTextRange) {
				var FieldRange = inputField.createTextRange();
				FieldRange.moveStart('character', inputField.value.length);
				FieldRange.collapse();
				FieldRange.select();
			} else if (inputField.selectionStart || inputField.selectionStart == '0') {
				var elemLen = inputField.value.length;
				inputField.selectionStart = elemLen;
				inputField.selectionEnd = elemLen;
				inputField.focus();
				$(inputField).click();
			}
		} else {
			inputField.focus();
			$(inputField).click();
		}
	}

	function keepAwake() {
		if (isPhoneGap()) {
			window.plugins.insomnia.keepAwake();
		}
	}

	function allowSleepAgain() {
		if (isPhoneGap()) {
			window.plugins.insomnia.allowSleepAgain();
		}
	}

	function pad(str, max) {
		return str.length < max ? pad("0" + str, max) : str;
	}

	function connectToWifiNetwork(parameters) {
		setTimeout(function() {
			// Scansione le reti WIFI disponibili
			$$('.modal-preloader .modal-title').html(Template7.global.lbl.SCAN_AVAILABLE_NETWORKS);
			WifiWizard.startScan(function(e) {
				setTimeout(function() {
					// Ottengo le reti WIFI
					WifiWizard.getScanResults(function(a) {
						var network_array = [];
						for (var i = 0; i < a.length; i++) {
							if (a[i].SSID.indexOf(parameters.SSID) != -1) {
								network_array.push(a[i].SSID);
							}
						}

						if (network_array.length > 0) {
							// Ordino per lunghezza, fallback in caso mancasse
							// Innova2.0, provo a collegarmi ad una rete con
							// "Innova2.0" nell'SSID
							network_array.sort(function(a, b) {
								return a.length - b.length;
							});

							var SSID = network_array[0], nfcwificonfig;
							if (parameters.password != "") {
								nfcwificonfig = WifiWizard.formatWPAConfig(SSID, parameters.password);
							} else {
								nfcwificonfig = WifiWizard.formatWifiConfig(SSID);
							}

							$$('.modal-preloader .modal-title').html(Template7.global.lbl.CONNECTING_TO + " " + SSID);

							setTimeout(function() {
								WifiWizard.addNetwork(nfcwificonfig, function(result) {
									Log("addNetwork ha avuto successo. Risultato: " + result);

									WifiWizard.connectNetwork(SSID, function() {
										Log("connectNetwork ha avuto successo. Risultato " + result);

										setTimeout(function() {
											$$('.modal-preloader .modal-title').html(Template7.global.lbl.CONNECTION_SUCCESSFUL);
											setTimeout(function() {
												checkSetup(parameters.app);
												return;
											}, 2500);
										}, 10000);
									}, function(error) {
										Log("Errore connessione rete: " + error);
										$$('.modal-preloader .modal-title').html(Template7.global.lbl.CONNECTION_ERROR);
										setTimeout(function() {
											f7.hidePreloader();
											router.load('devices', {});
										}, 1000);
									});
								}, function(error) {
									Log("Errore aggiunta rete: " + error);
									$$('.modal-preloader .modal-title').html(Template7.global.lbl.ADDING_NETWORK_ERROR);
									setTimeout(function() {
										f7.hidePreloader();
										router.load('devices', {});
									}, 1000);
								});
							}, 1000);
						} else {
							Log("Nessuna rete con chiave " + parameters.SSID + " trovata");
							$$('.modal-preloader .modal-title').html(Template7.global.lbl.ADDING_NETWORK_ERROR);
							setTimeout(function() {
								f7.hidePreloader();
								router.load('devices', {});
							}, 1000);
						}

					}, function(error) {
						Log("Errore ottenimento reti WIFI disponibili: " + error);
						$$('.modal-preloader .modal-title').html(Template7.global.lbl.CANNOT_OBTAIN_SCAN_RESULTS);
						setTimeout(function() {
							f7.hidePreloader();
							router.load('devices', {});
						}, 1000);
					});
				}, 3000);
			}, function(error) {
				Log("Errore scansione reti WIFI: " + error);
				$$('.modal-preloader .modal-title').html(Template7.global.lbl.SCAN_NETWORKS_ERROR);
				setTimeout(function() {
					f7.hidePreloader();
					router.load('devices', {});
					/*
					 * router.load('modal', { title :
					 * Template7.global.lbl.WARNING, message :
					 * Template7.global.lbl.SCAN_NETWORKS_ERROR, buttons : {
					 * reload : true, devices : true } });
					 */
				}, 1000);
			});
		}, 2000);
	}

	function getCurrentSSID(parameters) {
		WifiWizard.getCurrentSSID(function(ssid) {
			Log("SSID: " + ssid);
			Log("SSID passato: " + parameters.SSID);

			if (window.device.platform == "Android") {
				var find = '"', re = new RegExp(find, 'g');
				ssid = ssid.replace(re, '');
			}

			if (parameters.SSID == ssid) {
				// Se sono già nella rete del dispositivo
				// allora lo visualizzo direttamente
				checkSetup(parameters.app);
			} else {
				connectToWifiNetwork(parameters);
			}
		}, function(e) {
			Log("WifiWizard.getCurrentSSID error: " + e);

			connectToWifiNetwork(parameters);
		});
	}

	function networkConnection(parameters) {
		f7.hideIndicator();
		f7.hidePreloader();
		if (parameters == undefined) {
			parameters = {};
		}
		if (parameters.SSID == undefined) {
			parameters.SSID = Template7.global.ESSID_default;
		}
		if (parameters.password == undefined) {
			parameters.password = "";
		}

		f7.showPreloader(Template7.global.lbl.CONFIGURATION_IN_PROGRESS);
		if (isPhoneGap() && window.device.platform == "Android") {
			// Altrimenti attivo il procedimento di configurazione
			// guidata della rete

			// Progress bar
			var container = $$('.modal-preloader');
			if (container.children('.progressbar, .progressbar-infinite color-multi').length) {
			} else {
				f7.showProgressbar(container, 'multi');
			}

			// Abilito la connessione WIFI
			setTimeout(function() {
				$$('.modal-preloader .modal-title').html(Template7.global.lbl.CHECK_WIFI_CONNECTION);

				WifiWizard.setWifiEnabled(true, function(result) {
					if (result == 'OK') {
						$$('.modal-preloader .modal-title').html(Template7.global.lbl.OBTAINING_SSID);
						setTimeout(function() {
							getCurrentSSID(parameters);
						}, 5000);
					} else {
						Log("WifiWizard.setWifiEnabled problem: " + result);
						$$('.modal-preloader .modal-title').html(Template7.global.lbl.ERROR_WIFI_AUTO_CONNECTION);
						setTimeout(function() {
							window.location.reload();
						}, 2000);
					}
				}, function(error) {
					Log("WifiWizard.setWifiEnabled error: " + e);
					$$('.modal-preloader .modal-title').html(Template7.global.lbl.ERROR_WIFI_AUTO_CONNECTION);
					setTimeout(function() {
						window.location.reload();
					}, 2000);
				});
			}, 1000);
		} else {
			if (window.device != undefined && window.device.platform == "iOS") {
				Log("Sono su iOS");
				f7.hidePreloader();
				// iOS
				if (checkWifi()) {
					WifiWizard.getCurrentSSID(function(ssid) {
						Log("SSID: " + ssid);
						Log("SSID passato: " + parameters.SSID);

						if (parameters.SSID == ssid) {
							// Se sono già nella rete del dispositivo
							// allora lo visualizzo direttamente
							checkSetup(parameters.app);
						} else {
							router.load('modal', {
								title : Template7.global.lbl.WARNING,
								message : Template7.global.lbl.SEEMS_NOT_CONNECTED + ": <b>" + parameters.SSID + "</b></br>" + Template7.global.lbl.WHEN_CONNECTED,
								loop_message : Template7.global.lbl.WAITING_LIVE_CONNECTION,
								buttons : {
									loop : true,
									devices : true
								}
							});
						}
					}, function(e) {
						Log("WifiWizard.getCurrentSSID error: " + e);

						connectToWifiNetwork(parameters);
					});
				} else {
					noConnectionModal();
				}
			} else {
				f7.hidePreloader();

				// desktop
				checkSetup(parameters.app);
			}
		}
	}
	
	function saveLabels(labels) {
		if(labels === undefined) {
			return;
		}
		
		labels.forEach(function(lbl) {
			delete lbl.extended_title;
		});
		
		if (labels !== false) {
			setLocalConfig("labels", JSON.stringify(labels));
		}
		
		if(!isPhoneGap()) {
			// Desktop
		}
	}
	
	function getLabels() {
		var labels_json = getLocalConfig("labels");
		if (labels_json != undefined) {
			var labels = JSON.parse(labels_json);
			
			labels = getHierarchyLabels(labels);			
			return labels;
		} else {
			return [];
		}
	}
	
	function getLabelModel(payload) {
		var new_label = new LabelModel();
		new_label.load(payload);
		return new_label;
	}
	
	function getLabelFromUid(labels, uid) {		
		var label = false;
		labels.forEach(function(l) {
			if(l.uid == uid) {
				label = l;
				return false;
			}
		});
		return label;
	}
	
	function getRecHierarchy(label, labels) {
		if(label.parent_uid == -1) {
			return label.title;
		}
		return getRecHierarchy(getLabelFromUid(labels, label.parent_uid), labels) + " / " + label.title;
	}
	
	function countDevices(uid) {
		var devices = getDevices();
		if (devices == false) {
			// Se non ci sono dispositivi
			return 0;
		}
		
		var count = 0;
		Object.keys(devices).forEach(function (key) {
			devices[key] = getDeviceModel(devices[key]);
			
			if(devices[key].hasLabel(uid)) {
				count++;
			}
		});
		return count;
	}
	
	function getHierarchyLabels(labels) {
		var temp_labels = [];
		labels.forEach(function(lbl) {
			lbl.extended_title = getRecHierarchy(lbl, labels);
			lbl.n_devices = countDevices(lbl.uid);
			temp_labels.push(lbl);
		});
		return temp_labels;
	}
	
	function setMode(call, value, operation, parameters) {
		if(parameters === undefined) {
			parameters = {};
		}
		if(parameters.async === undefined) {
			parameters.async = true;
		}
		if(parameters.returnObject === undefined) {
			parameters.returnObject = false;
		}
		
		var mode = setNextMode(call, value, operation);

		data_POST = {};
		if (typeof mode === 'object') {
			data_POST = mode;
		} else {
			call = mode;
		}
		
		if(typeof mode === 'object') {
			googleAnalytics('send', 'event', call, mode[Object.keys(mode)[0]]);
		} else {
			googleAnalytics('send', 'event', call, mode);
		}
		
		var params2call={
			callback : function(data) {
				if (data.success == true) {
					if (parameters.callback_success != undefined) {
						parameters.callback_success(data);
					}					
				} else {
					if (parameters.callback_error != undefined) {
						parameters.callback_error(data.error);
					}		
				}
			},
			callback_error : function(jqXHR, textStatus, errorThrown) {
				if (parameters.callback_error != undefined) {
					parameters.callback_error(errorThrown);
				}	
			},
			extraData : "mode",
			async : parameters.async,
			data : data_POST,
			returnObject : parameters.returnObject
		};
		
		if(parameters.device !== undefined) {
			params2call.device=parameters.device;
		}
		
		if(params2call.returnObject == true) {
			return ajaxRequest("POST", getUrlApp(params2call) + call, params2call);
		}
		ajaxRequest("POST", getUrlApp(params2call) + call, params2call);
	}
	
	function setWorkingMode(mode, parameters) {
		ajaxRequest("POST", getUrlApp() + mode, {
			callback : function(data) {
				if (data.success == true) {
					if(parameters.callback_success !== undefined) {
						parameters.callback_success(data);
					}					
				} else {
					if(parameters.callback_error !== undefined) {
						parameters.callback_error(data.error);
					}
				}
				parameters.app.f7.hideIndicator();
			},
			extraData : "calendar"
		});
	}
	
	function setNextMode(call, value, operation) {
		var data = {};
		
		// In caso di programmazione avrò una stringa
		if(call != "calendar/program") {
			value = parseInt(value);
		}		

		switch (call) {
		case "set/setpoint":
			if (operation == "add") {
				if (value >= 16 && value < 31) {
					data.p_temp = value + 1;
				} else {
					data.p_temp = 31;
				}
			} else if (operation == "subtract") {
				// subtract
				if (value > 16 && value <= 31) {
					data.p_temp = value - 1;
				} else {
					data.p_temp = 16;
				}
			} else if(operation == "copy") {
				// copy setpoint
				if(value > 31) {
					value = 31;
				}
				if(value < 16) {
					value = 16;
				}				
				data.p_temp = value;
			}
			break;
		case "set/fan":
			if (value >= 0 && value < 3) {
				if(operation == "add" || operation == "subtract") {
					data.value = (operation == "add") ? value + 1 : value - 1;
				} else {
					// Copy fan
					data.value = value;
				}				
			} else {
				data.value = 0;
			}
			break;
		case "set/feature/rotation":
			if(operation == "copy") {
				// Copy feature rotation
				data.value = value;
			} else {
				if (value == 0) {
					data.value = 7;
				} else {
					data.value = 0;
				}
			}			
			break;
		case "set/feature/night":
			if(operation == "copy") {
				// Copy feature night
				data.value = value;
			} else {
				if (value == 0) {
					data.value = 1;
				} else {
					data.value = 0;
				}
			}
			break;
		case "set/calendar":
			if(operation == "copy") {
				// Copy feature night
				if (value == 0) {
					data = call + "/off";
				} else {
					data = call + "/on";
				}
			} else {
				if (value == 0) {
					data = call + "/on";
				} else {
					data = call + "/off";
				}
			}
			break;
		case "power":
			if(operation == "copy") {
				if (value == 0) {
					data = call + "/off";
				} else {
					data = call + "/on";
				}
			} else {
				if (value == 0) {
					data = call + "/on";
				} else {
					data = call + "/off";
				}
			}
			break;
		case "calendar/program":
			data.calendar = value;
			break;
		}
		return data;
	}
	
	function getNextMode(call, data) {
		if (typeof data === 'object') {
			if (typeof data.value != 'undefined') {
				return call + " = " + data.value;
			}
			if (typeof data.p_temp != 'undefined') {
				return call + " = " + data.p_temp;
			}
		} else {
			return data;
		}
		return "";
	}
	
	function getStatus(parameters) {
		if (parameters == undefined) {
			parameters = {};
		}
		if (parameters.syncTime == undefined) {
			parameters.syncTime = true;
		}
		if (parameters.skipNotification == undefined) {
			parameters.skipNotification = false;
		}
		if (parameters.async == undefined) {
			parameters.async = true;
		}
		if (parameters.device == undefined) {
			parameters.device = false;
		}
		
		ajaxRequest("GET", GetRisorsa("status", parameters), {
			callback : function(data) {
				if (data.success == true) {
					if(parameters.callback_success !== undefined) {
						parameters.callback_success(data);
					}					
				} else {
					if(parameters.callback_error !== undefined) {
						parameters.callback_error(data.error);
					}
				}
			},
			callback_error : function(jqXHR, textStatus, errorThrown) {
				if(parameters.callback_ajax_error !== undefined) {
					parameters.callback_ajax_error(errorThrown);
				}
			},
			extraData : "status",
			skipNotification : parameters.skipNotification,
			syncTime : parameters.syncTime,
			async : parameters.async,
			device : parameters.device
		});
	}
	
	function getWorkingMode(wMode) {
		var workingModeName = "";
		switch (wMode) {
		case Template7.global.MODE_HEATING:
			workingModeName = "heating";
			break;
		case Template7.global.MODE_COOLING:
			workingModeName = "cooling";
			break;
		case Template7.global.MODE_DEHUMIDIFICATION:
			workingModeName = "dehumidification";
			break;
		case Template7.global.MODE_FANONLY:
			workingModeName = "fanonly";
			break;
		case Template7.global.MODE_AUTO:
			workingModeName = "auto";
			break;
		}
		return workingModeName;
	}
	
	function ajaxManager(parameters) {
		if(parameters === undefined) {
			parameters = {};
		}
		
		return {
		    requests: [],
		    addReq: function(opt) {
		        this.requests.push(opt);

		        /*if (this.requests.length == 1) {
		            this.run();
		        }*/
		    },
		    removeReq: function(opt) {
		        if($.inArray(opt, requests) > -1)
		            this.requests.splice($.inArray(opt, requests), 1);
		    },
		    run: function() {
		    	if(this.requests[0] != undefined) {
		    		// original complete callback
			        oricomplete = this.requests[0].complete;

			        // override complete callback
			        var ajxmgr = this;
			        ajxmgr.requests[0].complete = function() {
			             if (typeof oricomplete === 'function')
			                oricomplete();

			             ajxmgr.requests.shift();
			             if (ajxmgr.requests.length > 0) {
			                ajxmgr.run();
			             }
			        };

			        $.ajax(this.requests[0]);
		    	}		        
		    },
		    stop: function() {
		        this.requests = [];
		    }
		};
	}
	
	function acceptTerms(parameters) {
		if(parameters == undefined) {
			parameters = {};
		}
		
		var acceptedTerms = getLocalConfig("accepted_terms");
		if(acceptedTerms != undefined && acceptedTerms != null && acceptedTerms === "true") {
			if(parameters.callback_accept != undefined) {
    			parameters.callback_accept();    			
    		}
			return;
		}
		
		// Visualizzo lo splash art
		$(".splash").show();
		
		f7.hidePreloader();
		
		var message = Template7.global.lbl.ACCEPT_TERMS_CONDITIONS;
		message = message.replace("{{link}}", "<a target='_blank' class='external' href='"+Template7.global.urlTermsConditions+"' >"+Template7.global.lbl.HERE+"</a>");
		
		f7.modal({
			title : Template7.global.lbl.TERMS_CONDITIONS,
			text : message,
			closable : false,
			buttons : [ {
				text : Template7.global.lbl.ACCEPT,
				bold : true,
				close : true,
				onClick : function() {
					setLocalConfig("accepted_terms", "true");
					// Nascondo lo splash art
					$(".splash").hide();

					if (parameters.callback_accept != undefined) {
						parameters.callback_accept();
					}
				}
			}, {
				text : Template7.global.lbl.DECLINE,
				close : true,
				onClick : function() {
					if (parameters.callback_decline != undefined) {
						parameters.callback_decline();
					}
				}
			} ]
		});
	}

	return {
		checkConnection : checkConnection,
		checkWifi : checkWifi,
		inArray : inArray,
		setRouter : setRouter,
		getAppLabels : getAppLabels,
		Log : Log,
		getLocalConfig : getLocalConfig,
		GetRisorsa : GetRisorsa,
		exitFromApp : exitFromApp,
		exitAppPopup : exitAppPopup,
		setLocalConfig : setLocalConfig,
		WindowOpen : WindowOpen,
		setApp : setApp,
		googleAnalytics : googleAnalytics,
		getUrlApp : getUrlApp,
		ajaxRequest : ajaxRequest,
		setCurrentDevice : setCurrentDevice,
		getCurrentDevice : getCurrentDevice,
		getPreferredDevice : getPreferredDevice,
		setPreferredDevice : setPreferredDevice,
		getDeviceModel : getDeviceModel,
		getDevices : getDevices,
		saveDevices : saveDevices,
		getDeviceByUID : getDeviceByUID,
		saveDevice : saveDevice,
		replaceAt : replaceAt,
		findIP : findIP,
		isPhoneGap : isPhoneGap,
		noConnectionModal : noConnectionModal,
		RegisterPushNotification : RegisterPushNotification,
		SetPushNotification : SetPushNotification,
		DeletePushNotification : DeletePushNotification,
		SettingsPushNotification : SettingsPushNotification,
		checkSetup : checkSetup,
		focusField : focusField,
		keepAwake : keepAwake,
		allowSleepAgain : allowSleepAgain,
		unsetCurrentDevice : unsetCurrentDevice,
		pad : pad,
		deleteDevice : deleteDevice,
		networkConnection : networkConnection,
		saveLabels : saveLabels,
		getLabelModel : getLabelModel,
		getLabels : getLabels,
		getLabelFromUid : getLabelFromUid,
		getHierarchyLabels : getHierarchyLabels,
		getRecHierarchy : getRecHierarchy,
		setMode : setMode,
		setNextMode : setNextMode,
		getNextMode : getNextMode,
		getStatus : getStatus,
		getWorkingMode : getWorkingMode,
		ajaxManager : ajaxManager,
		setWorkingMode : setWorkingMode,
		syncLocalStorage : syncLocalStorage,
		setLocalStorage : setLocalStorage,
		acceptTerms : acceptTerms
	};
});